"""autogenerated by genpy from grizzly_msgs/RawStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class RawStatus(genpy.Message):
  _md5sum = "1f60c3c0abd6518a31d1f3fa02872ac9"
  _type = "grizzly_msgs/RawStatus"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header

float32 voltage       # [V] Main 48V bus voltage
float32 user_current  # [A] Total power draw from regulated rails
float32 body_temp_adc # [C] Temperature adc reading of enclosure
bool fans_on        # TRUE when fans on

int16 rc_override   # [us] Pulse length of this channel
uint16 rc_velocity  # [us] Pulse length of this channel
uint16 rc_rotation  # [us] Pulse length of this channel

uint8 error
uint8 ERROR_COMMAND_TIMEOUT=1
uint8 ERROR_UNDERVOLT=2
uint8 ERROR_ESTOP=4
uint8 ERROR_ESTOP_RESET=8
uint8 ERROR_BRK_DET=16

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  # Pseudo-constants
  ERROR_COMMAND_TIMEOUT = 1
  ERROR_UNDERVOLT = 2
  ERROR_ESTOP = 4
  ERROR_ESTOP_RESET = 8
  ERROR_BRK_DET = 16

  __slots__ = ['header','voltage','user_current','body_temp_adc','fans_on','rc_override','rc_velocity','rc_rotation','error']
  _slot_types = ['std_msgs/Header','float32','float32','float32','bool','int16','uint16','uint16','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,voltage,user_current,body_temp_adc,fans_on,rc_override,rc_velocity,rc_rotation,error

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RawStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.voltage is None:
        self.voltage = 0.
      if self.user_current is None:
        self.user_current = 0.
      if self.body_temp_adc is None:
        self.body_temp_adc = 0.
      if self.fans_on is None:
        self.fans_on = False
      if self.rc_override is None:
        self.rc_override = 0
      if self.rc_velocity is None:
        self.rc_velocity = 0
      if self.rc_rotation is None:
        self.rc_rotation = 0
      if self.error is None:
        self.error = 0
    else:
      self.header = std_msgs.msg.Header()
      self.voltage = 0.
      self.user_current = 0.
      self.body_temp_adc = 0.
      self.fans_on = False
      self.rc_override = 0
      self.rc_velocity = 0
      self.rc_rotation = 0
      self.error = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3fBh2HB.pack(_x.voltage, _x.user_current, _x.body_temp_adc, _x.fans_on, _x.rc_override, _x.rc_velocity, _x.rc_rotation, _x.error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.voltage, _x.user_current, _x.body_temp_adc, _x.fans_on, _x.rc_override, _x.rc_velocity, _x.rc_rotation, _x.error,) = _struct_3fBh2HB.unpack(str[start:end])
      self.fans_on = bool(self.fans_on)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3fBh2HB.pack(_x.voltage, _x.user_current, _x.body_temp_adc, _x.fans_on, _x.rc_override, _x.rc_velocity, _x.rc_rotation, _x.error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.voltage, _x.user_current, _x.body_temp_adc, _x.fans_on, _x.rc_override, _x.rc_velocity, _x.rc_rotation, _x.error,) = _struct_3fBh2HB.unpack(str[start:end])
      self.fans_on = bool(self.fans_on)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3fBh2HB = struct.Struct("<3fBh2HB")
_struct_3I = struct.Struct("<3I")
